﻿using System;
using System.Drawing;
using System.Reflection;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using System.Diagnostics;
using Infragistics.Win.UltraWinSchedule.TimelineView;

namespace WinTimeLineViewMultiOwnerSelect
{
	public class DrawFilter: IUIElementDrawFilter 
	{
		#region Constructor

		public DrawFilter()
		{
		}

		#endregion Constructor

		#region GetPhasesToFilter

		DrawPhase IUIElementDrawFilter.GetPhasesToFilter( ref UIElementDrawParams drawParams )
		{
			return DrawPhase.BeforeDrawBackColor;
		}

		#endregion GetPhasesToFilter

		#region DrawElement

		bool IUIElementDrawFilter.DrawElement( DrawPhase drawPhase, ref UIElementDrawParams drawParams )
		{

            if (drawParams.Element is Infragistics.Win.UltraWinSchedule.TimelineView.TimeSlotUIElement)
            {

                Infragistics.Win.UltraWinSchedule.TimelineView.TimeSlotUIElement ts = drawParams.Element as Infragistics.Win.UltraWinSchedule.TimelineView.TimeSlotUIElement;
                //ColumnHeaderUIElement col = drawParams.Element as ColumnHeaderUIElement;

                bool selected;

                DateTimeRange selectedRange = ((UltraTimelineView)drawParams.Element.Control).SelectedDateTimeRange;
                if (selectedRange == null)
                {
                    selected = false;
                }
                else
                {
                    DateTime startTime1 = ts.DateTimeRange.StartDateTime;
                    DateTime endTime1 = ts.DateTimeRange.EndDateTime;
                    selected = selectedRange.IntersectsWith(startTime1, endTime1);

                }

                if (selected)
                {
                    drawParams.AppearanceData.BackColor = Color.Red;
                    drawParams.AppearanceData.BackColor2 = Color.Red;
                }
            }

           

			return false;
		}

		#endregion DrawElement
	}

}
